10 remark $$chan=4
11 remark $$stak=512
12 remark $$asmb=win1_ptr_mod_MODVIEW_CDE,0,16
13 :
14 :
15 rem + ======================================================================== +
16 rem |<                              View Modules                              >|
17 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
18 rem || Module Viewer (Perhaps later Module Manager)                           ||
19 rem || Based on:                                                              ||
20 rem || SMSQ for modules                                                       ||
21 rem || Tony Tebby, IQLR V5/5-96                                              ||
22 rem ||                                                                        ||
23 rem || V0.02, pjw, June 9th 2017                                              ||
24 rem || V0.03, pjw, June 30th 2017, bug fixes, REPORT_ERROR, CMD$              ||
25 rem || V0.04, pjw, July 11th 2017, Exchanged REPORT_ERROR for MSX             ||
26 rem || V0.05, pjw, July 26th 2017, New check for correct file                 ||
27 rem || V0.06, pjw, September 4th 2017, Replaced JobLives with JOB$            ||
28 rem + ======================================================================== +
29 :
30 :
31 :
32 rem + ======================================================================== +
33 rem |<                                  Init                                  >|
34 rem + ======================================================================== +
35 rem | Initialise GLOBal variables                                              |
36 rem + ------------------------------------------------------------------------ +
37 :
38 rem     Program and Window Variables
39 li_refresh%     =   -1
40 li_sleep%       =   -2
41 li_quit%        =   -3
42 li_input%       =   -4
43 li_help%        =   -5
44 li_command%     =   -6
45 li_wmove%       =   -7
46 aw_title%       =    1
47 aw_disp%        =    2
48 iw_mess%        =    3
49 iw_index%       =    4
50 :
51 lines%          =    7
52 chars%          =   43
53 loaded          =    0
54 wwd             =   -1: rem -> Window Working Definition
55 :
56 rem     Wman constants (remove those not used later)
57 ww_xsize        =  32: rem .w  $20  window x size (width) in pixels
58 ww_ysize        =  34: rem .w  $22  window y size (height) in pixels
59 ww_xorg         =  36: rem .w  $24  x origin of window
60 ww_yorg         =  38: rem .w  $26  y origin of window
61 ww_nappl        = 110: rem .w  $6e  number of application sub-windows
62 ww_pappl        = 112: rem .l  $70  pointer to application sub-window definition list
63 :
64 wwa_xsiz        =   0: rem .w  $00  sub-window x size (width) in pixels
65 wwa_ysiz        =   2: rem .w  $02  sub-window y size (height) in pixels
66 wwa_xorg        =   4: rem .w  $04  sub-window x origin
67 wwa_yorg        =   6: rem .w  $06  sub-window y origin
68 ws_citem        =  48: rem .l  $30  current item in sub-window
69 :
70 sp_titlebg%     = 516: rem Title background
71 sp_titletextbg% = 517: rem Title text background
72 sp_titlefg%     = 518: rem Title foreground
73 sp_litemavabg%  = 520: rem Loose item available background
74 sp_litemavafg%  = 521: rem Loose item available foreground
75 sp_infwinbg%    = 527: rem Information window background
76 sp_infwinfg%    = 528: rem Information window foreground
77 sp_infwinmg%    = 529: rem Information window middleground
78 sp_infwinfg%    = 528: rem Information window foreground
79 sp_infwinbg%    = 527: rem Information window background
80 sp_mindexfg%    = 567: rem Menu index foreground
81 sp_hintbg%      = 553: rem Hint background
82 sp_hintfg%      = 554: rem Hint foreground
83 sp_hintmg%      = 555: rem Hint middleground
84 :
85 :
86 rem + ------------------------------------------------------------------------ +
87 rem |<                         Program Initialisation                         >|
88 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
89 rem | Read Config file, open and initialise windows and menus                  |
90 rem + ------------------------------------------------------------------------ +
91 :
92 if len(CMD$): home$ = CMD$: else: home$ = home_dir$
93 cfg = GetConfig
94 :
95 ch = fopen('con_'): if ch < 0: ert ch
96 ch% = ch
97 mdraw#ch%; MN_MVIEW
98 Title#ch%; aw_title%, 'Module Viewer'
99 wwd = mwdef(#ch%): rem Global -> Window Working Definition
100 cip = peek_l(wwd) + ws_citem: rem Pointer to current item
101 :
102 if cfg < 0: ErrMess 'Error', 'Configuration file error: ' & cfg: quit
103 dim filename$(42), pv%(16)
104 filename = Alloc(44)
105 :
106 mwindow#ch%; aw_disp%
107 wm_ink#ch%; sp_infwinfg%: wm_paper#ch%; sp_infwinbg%
108 print#ch%; Center$('Module Viewer V0.02', chars%)
109 print#ch%\\ Center$('Enter an SMSQ/E filename to view', chars%)
110 filename$ = smsdir$
111 poke_w filename, len(filename$)
112 poke filename + 2, filename$
113 mitem#ch%; li_input%, 0, filename
114 :
115 dim com$(3, 12), comu%(3)
116 com$(0) = 'Save List':    comu%(0) = 6
117 com$(1) = 'Append List':  comu%(1) = 1
118 com$(2) = 'Save Scrap':   comu%(2) = 1
119 com$(3) = 'Append Scrap': comu%(3) = 2
120 :
121 it%             = 999: REMark Current item
122 stat%           =   0: k = 0: ev% = 0
123 :
124 :
125 :
126 rem + ======================================================================== +
127 rem |<                           Main Program Loop                            >|
128 rem + ======================================================================== +
129 :
130 REPeat mainloop
131  if stat% then
132   k = MCALLT(#wwd, ev%, timep%)
133  else
134   k = MCALLT(#wwd, ev%, timep%, k, stat%)
135  endif
136  pval#wwd; pv%: ev% = 0
137 :
138  sel on k
139   = -1280: rem Popup
140     lit% = it%
141     it% = -1 - PEEK_W(cip): rem Get current Item
142     if (pv%(2) + 1) = aw_disp% and it% <= 0 then
143      it% = aw_disp%
144     else
145      if it% = 252: it% = pv%(2) + 1
146     endif
147     if it% = lit%: stat% = 1: next mainloop: else: stat% = 0
148     sel on it%
149      = li_refresh%:      Pop 'Refresh', pv%
150      = li_sleep%:        Pop 'Sleep', pv%
151      = li_quit%:         Pop 'Quit', pv%
152      = li_input%:        Pop 'Input', pv%
153      = aw_title%:        Pop 'Move Window', pv%
154      = aw_disp%:         Pop 'List of modules', pv%
155      = remainder
156        rem Pop 'Dont know ' & it%, pv%
157     endsel
158     next mainloop
159 :
160   = li_refresh%
161     if loaded then
162      er = LoadFile
163      if not er: pause#ch%; 300: Mess '': else: Ping
164     else
165      Burp
166     endif
167   = li_sleep%:          rem Sleep
168   = li_quit%:           Quit 0
169   = li_input%:
170        er = GetFilename
171        if er then
172         er = LoadFile
173        endif
174        if not er: pause#ch%; 300: Mess ''
175   = li_help%:   Mess 'Help'
176   = li_command%:        Command
177   = li_wmove%:          wmov#ch%; -1
178   = aw_title%:          if pv%(5): wmov#ch%; -1
179   = mencon to 5e9: rem Mess 'Item ' & k
180     if pv%(5) = 1: Command
181   = remainder: rem Mess 'Remainder ' & k
182  endsel
183  stat% = 0
184 END REPeat mainloop
185 :
186 :
187 rem + ------------------------------------------------------------------------ +
188 rem |<                            Main Subroutines                            >|
189 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
190 rem | Uses main's GLOBals                                                      |
191 rem + ------------------------------------------------------------------------ +
192 :
193 :
194 rem + ------------------------------------------------------------------------ +
195 rem |<                                Re-Draw                                 >|
196 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
197 rem | Draw and Redraw Main Windows                                             |
198 rem + ------------------------------------------------------------------------ +
199 :
200 def proc Redraw(xp%, yp%, xs%, ys%)
201 mclear#ch%
202 mdraw#ch%; MN_MVIEW, xp%, yp%, xs%, ys%
203 Title#ch%, aw_title%, 'Module Viewer'
204 mwindow#ch; iw_index%! 0
205 wm_ink#ch%; sp_mindexfg%
206 print#ch%; '  len   vers'; fill$(' ', dimn(names$(0)) / 2 - 2); 'name';
207 mitem#ch%; li_input%, 0, filename
208 mlidraw#ch%; li_input%
209 mawdraw#ch%, aw_disp%, disp$
210 enddef Redraw
211 :
212 :
213 rem + ------------------------------------------------------------------------ +
214 rem |<                              GetFilename                               >|
215 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
216 rem | Get or Select a filename                                                 |
217 rem + ------------------------------------------------------------------------ +
218 :
219 def fn GetFilename
220 loc cf, fnm$(42)
221 rem Uses caller's locals
222 :
223 if (pv%(5) = 1 or pv%(6) = 236) and fsel then
224  SelectFile
225 else
226  mwindow#ch%; li_input%
227  wm_paper#ch%; sp_infwinbg%: wm_ink#ch%; sp_infwinfg%
228  over#ch%; 0: cls#ch%: cursor#ch%; 2, 2
229  minput#ch%; filename
230 endif
231 :
232 if peek_w(filename) = 0 then
233  poke_w filename, len(filename$)
234  poke filename + 2, filename$
235  Mess 'No file'
236  ret 0
237 endif
238 :
239 fnm$ = peek$(filename + 2, peek_w(filename))
240 cf = FOP_IN(fnm$)
241 if cf < 0 then
242  Mess 'Error: ' & cf
243  ret 0
244 endif
245 :
246 if ftyp(#cf) = 255 then
247  close#cf
248  Mess 'Incomplete name'
249  ret 0
250 endif
251 :
252 close#cf
253 filename$ = fnm$
254 ret 1
255 enddef GetFilename
256 :
257 :
258 rem + ------------------------------------------------------------------------ +
259 rem |<                                LoadFile                                >|
260 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
261 rem | Read Moduless, prepare and display                                       |
262 rem + ------------------------------------------------------------------------ +
263 :
264 def fn LoadFile
265 loc i
266 rem Uses caller's locals
267 :
268 rows = Read_Modules(filename$)
269 :
270 if rows < 0 then
271  if rows = -16 then
272   Mess 'Wrong or corrupt file'
273  else
274   Mess 'No modules found'
275  endif
276  ret 0
277 endif
278 :
279 cols = dimn(names$(0)) + 13
280 if (rows + 6) > lines% or (cols + 2) > chars% then
281  lines% = rows: chars% = cols
282 endif
283 :
284 dim disp$(rows, chars%)
285 for i = 0 to rows
286  disp$(i) = hex$(length(i), 24) & ' ' & version$(i) & '  ' & names$(i)
287 endfor i
288 :
289 Redraw peek_w(wwd + ww_xorg), peek_w(wwd + ww_yorg), chars% * 6 + 14, lines% * 11 + 80
290 loaded = 1
291 :
292 Mess (rows + 1) & ' modules plus host module.'
293 ret 1
294 enddef LoadFile
295 :
296 :
297 rem + ------------------------------------------------------------------------ +
298 rem |<                              Read_Modules                              >|
299 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
300 rem | Main routine. Adabpted from Tony Tebby's sample routine in Modules.doc   |
301 rem |                                                                          |
302 rem | pjw, V0.01, June 2017                                                    |
303 rem + ------------------------------------------------------------------------ +
304 :
305 def fn Read_Modules(fnm$)
306 loc cf, i, fln, bln, mod_ptr, mp, mxl%
307 loc mbase, mlength, name_rel, a, mvers$(4), mname$
308 rem GLOBal length(), version$(), names$()
309 :
310 cf = FOP_IN(fnm$): if cf < 0: ret cf
311 :
312 mvers$(0) = 4: mxl% = 2
313 fln = FLEN(#cf)
314 :
315 rem Quick and dirty test for SMSQ file:
316 if fln < 256: close#cf: ret -7: rem Optimistic!
317 bget#cf\ fln - 28, mvers$(1 to 4)
318 if mvers$ <> ' END': close#cf: ret -16
319 :
320 LGET#cf\ fln - 20, mod_ptr:             REMark len host module
321 LGET#cf\ fln -  4, bln:                 REMark len bootloader file
322 IF bln: mod_ptr = mod_ptr + fln - bln
323 mp = mod_ptr
324 rem Mess 'mp=' & mp & ', bln=' & bln: pause#ch%
325 :
326 rem First count:
327 FOR i = 0 TO 9999
328  LGET#cf\ (mod_ptr), mbase, mlength
329  IF NOT mbase: EXIT i
330  WGET#cf\ (mod_ptr + 22), name_rel:     REMark relative ptr to name
331  GET#cf\ (mod_ptr + 22 + name_rel), mname$
332  IF LEN(mname$) > mxl%: mxl% = len(mname$)
333  mod_ptr = mod_ptr + mbase + mlength
334 END FOR i
335 :
336 i = i - 1
337 dim length(i), version$(i, 6), names$(i, mxl%)
338 mod_ptr = mp
339 :
340 FOR i = 0 TO 9999
341  LGET#cf\ (mod_ptr), mbase, mlength
342  IF NOT mbase: EXIT i
343  length(i) = mlength
344  WGET#cf\ (mod_ptr + 22), name_rel:     REMark relative ptr to name
345  GET#cf\ (mod_ptr + 22 + name_rel), names$(i)
346  IF LEN(names$(i)) && 1: BGET#cf; a:    REMark - odd length name is padded
347  BGET#cf; mvers$(1 TO 4):               REMark - get version, if any
348  version$(i) = mvers$
349  mod_ptr = mod_ptr + mbase + mlength
350 END FOR i
351 CLOSE#cf
352 ret i - 1
353 enddef Read_Modules
354 :
355 :
356 rem + ------------------------------------------------------------------------ +
357 rem |<                     Save Data Routines for ViewMod                     >|
358 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
359 :
360 def proc Scrap(app%)
361 loc i%
362 if app%: scrap_put 0, chr$(10) & chr$(10), 1
363 scrap_put 0, filename$ & chr$(10), app%
364 for i% = 0 to dimn(disp$)
365  scrap_put 0, disp$(i%) & chr$(10), 1
366 endfor i%
367 Ping
368 enddef Scrap
369 :
370 :
371 def fn Save_list(app%)
372 loc cf, i%
373 if app% = 0 then
374  cf = fop_over(list$)
375 else
376  cf = fopen(list$)
377  if cf = -7 then
378   cf = fop_over(list$)
379   app% = 0
380  endif
381 endif
382 :
383 if cf < 0: ret cf
384 if app% then
385  get#cf\ flen(#cf)
386  bput#cf; 10, 10
387 endif
388 :
389 print#cf; filename$
390 for i% = 0 to dimn(disp$)
391  bput#cf; disp$(i%), 10
392 endfor i%
393 close#cf
394 Ping
395 ret 0
396 enddef Save_list
397 :
398 :
399 rem + ------------------------------------------------------------------------ +
400 rem |<                       List Save Submenu Command                        >|
401 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
402 :
403 def proc Command
404 loc sl%
405 :
406 if not loaded: Burp: ret
407 er = 0
408 st% = mstat%(#ch%; k, 0): rem Clear current selection
409 sl% = SubMen(-1, -1, com$, comu%)
410 sel on sl%
411  = -1: ret: rem Esc
412  =  1: er = Save_list(0)
413  =  2: er = Save_list(1)
414  =  3: Scrap 0
415  =  4: Scrap 1
416  = remainder: Mess '? ' & sl%
417  endsel
418 if er < 0: Mess 'Error ' & list$ & ': ' & er
419 enddef Command
420 :
421 :
422 :
423 rem + ======================================================================== +
424 rem |<             Assorted (tailored) General Purpose Subroutines            >|
425 rem + ======================================================================== +
426 :
427 :
428 rem + ------------------------------------------------------------------------ +
429 rem |<                               Get Config                               >|
430 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
431 rem | Read Configuration File                                                  |
432 rem + ------------------------------------------------------------------------ +
433 :
434 def fn GetConfig
435 loc ch, p%, lp, l$, t$
436 smsdir$         = datad$
437 fsel$           = home$ & 'Fsel_bas'
438 fmsx$           = home$ & 'Msx_obj'
439 temp$           = 'ram1_'
440 pal$            = 0: palette = 0
441 sound           = 1
442 timep%          = 100: REMark Timeout before pop-up
443 timed%          = 300: REMark Pop-up display time
444 fmsx            =   1: rem Assume messages present
445 :
446 ch = CheckID(home$ & "ModView_cfg", 'ModView01')
447 if ch < 0: ret ch
448 :
449 rep lp
450  if eof(#ch): exit lp
451  input#ch; l$
452  if len(l$) = 0: next lp
453  if l$(1) = '*': next lp
454  t$ = GtCfgIt$("fileselect "): if len(t$): fsel$  = t$: next lp
455  t$ = GtCfgIt$("message ")   : if len(t$): fmsx$  = t$: next lp
456  t$ = GtCfgIt$("smsdir ")    : if len(t$) and t$ <> '*': smsdir$ = t$: next lp
457  t$ = GtCfgIt$("list ")      : if len(t$) and t$ <> '*': list$  = t$: next lp
458  t$ = GtCfgIt$("palette ")   : if len(t$): pal$  = t$: next lp
459  t$ = GtCfgIt$("sound ")     : if len(t$): sound = t$ == 'on': next lp
460  t$ = GtCfgIt$("poptime ")
461  if len(t$) then
462   timep% = t$(1) instr '0123456789'
463   if timep% = 0: timep% = 100: next lp
464   timep% = timep% - 1
465   if timep% = 0: timep% = -1: else: timep% = timep% * 50
466   next lp
467  endif
468  t$ = GtCfgIt$("popdisp ")
469  if len(t$) then
470   timed% = t$(1) instr '123456789'
471   if timed% = 0: timed% = 300: next lp
472   timed% = timed% * 50
473   next lp
474  endif
475 endrep lp
476 close#ch: ch = 0: rem Re-use variable
477 if smsdir$(len(smsdir$)) <> '_': smsdir$ = smsdir$ & '_'
478 if len(temp$) > 0 then
479  if temp$(len(temp$)) <> '_': temp$ = temp$ & '_'
480 else
481  temp$ = "ram1_mod_txt"
482 endif
483 :
484 if len(fsel$) then
485  if fsel$(1) = '*': fsel$ = home$ & fsel$(2 to len(fsel$))
486  fsel = ftest(fsel$) = 0
487 else
488  fsel = 0
489 endif
490 :
491 if len(fmsx$) then
492  if fmsx$(1) = '*': fmsx$ = home$ & fmsx$(2 to len(fmsx$))
493  fmsx = ftest(fmsx$) = 0
494 else
495  fmsx = 0
496 endif
497 :
498 if len(pal$) < 1 then
499  palette = 0
500 else
501  if len(pal$) = 1 then
502   ch = PalSet(pal$)
503  else
504   if pal$(1) = '*': pal$ = home$ & pal$(2 to len(pal$))
505   ch = PalSet(-1, pal$)
506  endif
507 endif
508 if ch < 0: palette = 0: else: palette = ch
509 :
510 ret ch
511 enddef GetConfig
512 :
513 rem + ------------------------------------------------------------------------ +
514 rem |<                                GtCfgIt$                                >|
515 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
516 rem | Get single Config Item (Subroutine of GetConfig)                         |
517 rem + ------------------------------------------------------------------------ +
518 :
519 def fn GtCfgIt$(it$)
520 if (it$ instr l$) <> 1: ret ''
521 p% = '=' instr l$
522 if p% = 0: ret ''
523 t$ = DESP$(l$(p% + 1 to len(l$)))
524 for p% = 1 to len(t$)
525  if t$(p%) = ' ': p% = p% - 1: exit p%
526 endfor p%
527 ret t$(1 to p%)
528 enddef GtCfgIt$
529 :
530 :
531 rem + ------------------------------------------------------------------------ +
532 rem |<                                  Mess                                  >|
533 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
534 rem | General purpose simple Messaging Routine                                 |
535 rem + ------------------------------------------------------------------------ +
536 :
537 def proc Mess(tx$)
538 mwindow#ch%; iw_mess%! 0
539 cls#ch%: cursor#ch%; 2, 1: bput#ch%; tx$
540 enddef Mess
541 :
542 :
543 rem + ------------------------------------------------------------------------ +
544 rem |<                                 Title                                  >|
545 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
546 rem | General purpose Fit title into top Appication window (Also submenus)     |
547 rem |                                                                          |
548 rem | pjw, V0.0x, simplified                                                   |
549 rem + ------------------------------------------------------------------------ +
550 :
551 def proc Title(ch, aw%, txt$)
552 :
553 Tit sp_titlebg%, sp_titlefg%, sp_titletextbg%
554 enddef Title
555 :
556 def proc Tit(p%, i%, s%)
557 loc l%, x%, y%, ww, t$
558 rem Subroutine of Title and TitleSub
559 :
560 ww = mwdef(#ch)
561 GetAWsize ww, aw%, x%, y%
562 l% = len(txt$) * 6
563 if l% > x% then
564  t$ = txt$(1 to (x% div 6) - 2) & dots$
565 else
566  t$ = txt$
567 endif
568 l% = len(t$) * 6
569 :
570 mwindow#ch\ aw%
571 wm_paper#ch; p%: wm_ink#ch; i%: cls#ch
572 wm_block#ch; l% + 8, 12, (x% - l%) div 2 - 2, ((y% - 12) div 2), s%
573 cursor#ch; (x% - l%) div 2 + 2, (y% - 12) div 2 + 1
574 bput#ch; t$
575 enddef Tit
576 :
577 :
578 rem + ------------------------------------------------------------------------ +
579 rem |<                               SelectFile                               >|
580 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
581 rem | File selection util using QMenu FILE_SELECT$ in a wrapper program, FSEL  |
582 rem |                                                                          |
583 rem | pjw, V0.s4, June 2017, simplified for this purpose                       |
584 rem + ------------------------------------------------------------------------ +
585 :
586 def proc SelectFile
587 loc x%, y%, cl$(128)
588 :
589 st% = mstat%(#ch%; k, 0)
590 x% = peek_w(wwd + ww_xorg) - (448 - peek_w(wwd + ww_xsize)) / 2
591 y% = peek_w(wwd + ww_yorg) + 40
592 cl$ = '/X' & x% & ' /Y' & y% & ' /D ' & filename$ & ' /F ' & filename$
593 cl$ = cl$ & ' /R ' & hex$(filename, 32) & ' /P ' & hex$(palette, 32)
594 ExExt fsel$, cl$
595 enddef SelectFile
596 :
597 :
598 rem + ------------------------------------------------------------------------ +
599 rem |<                                 PalSet                                 >|
600 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
601 rem | Set job's Palette, 0..3 or load binary! theme file                       |
602 rem |                                                                          |
603 rem | pjw, V0.02, June 2017                                                    |
604 rem + ------------------------------------------------------------------------ +
605 :
606 DEFine FuNction PalSet(pal, thb$)
607 LOCal er
608 rem Set system palette or load and set (binary!) theme
609 rem May alter parameter pal
610 IF pal = -1 THEN
611  er = FTEST(thb$)
612  IF er < 0: RETurn er
613  IF FLEN(\ thb$) <> SP_GETCOUNT * 2: RETurn -12
614  pal = Alloc(SP_GETCOUNT * 2)
615  LBYTES thb$, pal
616  SP_JOBOWNPAL -1, pal
617 ELSE
618  IF pal > 3: RETurn -15
619  SP_JOBPAL -1, pal
620 END IF
621 RETurn pal
622 END DEFine PalSet
623 :
624 :
625 rem + ------------------------------------------------------------------------ +
626 rem |<                                  Pop                                   >|
627 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
628 rem | General purpose popup routine                                            |
629 rem |                                                                          |
630 rem | pjw, V 0.02, March 31st 2005 (Cut down)                                  |
631 rem + ------------------------------------------------------------------------ +
632 :
633 DEFine PROCedure Pop(txt$, pv%)
634 LOCal cp%, l%, x%, y%, xp%
635 :
636 x% = pv%(14): y% = pv%(15)
637 l% = len(txt$) * 6 + 4
638 xp% = x% - (l% DIV 2): IF xp% < 1: xp% = 1
639 :
640 cp% = FOPEN('con_')
641 MDRAW#cp%; MN_POPUP, xp%, y% + 2, l%, 12
642 WM_INK#cp%; sp_hintfg%: WM_PAPER#cp%; sp_hintbg%
643 CURSOR#cp%; 2, 1: bput#cp%; txt$
644 RDPT#cp%, 11, x%, y% + 2, timed%
645 MCLEAR#cp%: CLOSE#cp%
646 END DEFine Pop
647 :
648 :
649 rem + ------------------------------------------------------------------------ +
650 rem |<                                 Submen                                 >|
651 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
652 rem | General purpose submenu menu                                             |
653 rem |                                                                          |
654 rem | pjw, V0.02, June 2017                                                    |
655 rem + ------------------------------------------------------------------------ +
656 :
657 def fn SubMen(xp%, yp%, dislst$, undchr%)
658 loc cs%, ls, k, st%, xs%, ys%
659 :
660 ys% = dimn(dislst$) * 11 + 28
661 xs% = dimn(dislst$(0)) * 6 + 12
662 cs% = fopen("con_")
663 mdraw#cs%; mn_sub, xp%, yp%, xs%, ys%
664 mawdraw#cs%; 2, dislst$, 0, 0, undchr%
665 :
666 rep ls
667  k = mcall(#cs%, k, st%)
668  sel on k
669   =  1: if mkey%(#cs%) instr '12': wmov#cs%; -1
670   = -1: xs% = -1: exit ls
671   =  remainder: xs% = (k - 2) / 65535
672      exit ls
673  endsel
674  st% = 0
675 endrep ls
676 mclear#cs%: close#cs%
677 ret xs%
678 enddef SubMen
679 :
680 :
681 rem + ------------------------------------------------------------------------ +
682 rem |<                               Check ID                                 >|
683 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
684 rem | Open an IDed file and check for correct ID                               |
685 rem | If ok, return its open channel, with file pointer just past ID           |
686 rem + ------------------------------------------------------------------------ +
687 :
688 def fn CheckID(fnm$, id$)
689 loc ch, p%, c$
690 ch = fopen(fnm$)
691 if ch < 0: ret ch
692 for p% = 1 to len(id$)
693  c$ = inkey$(#ch; 50)
694  if len(c$) = 0 or c$ <> id$(p%) then
695   close#ch: ret -12: rem Not our config file
696  endif
697 endfor p%
698 ret ch
699 enddef CheckID
700 :
701 :
702 rem + ------------------------------------------------------------------------ +
703 rem |<                                 ExExt                                  >|
704 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
705 rem | Execute External app                                                     |
706 rem |                                                                          |
707 rem | V0.02, pjw, September 4th 2017, Self contained                           |
708 rem + ------------------------------------------------------------------------ +
709 :
710 def proc ExExt(fnm$, cl$)
711 loc hl, id
712 id = FEX_M(fnm$; cl$)
713 REPeat hl
714  RDPT#ch%; 6
715  IF LEN(JOB$(id)) = 0: EXIT hl
716  PTOP#ch%; id
717 END REPeat hl
718 enddef ExExt
719 :
720 :
721 rem + ------------------------------------------------------------------------ +
722 rem |<                               GetAWsize                                >|
723 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
724 rem | One of the general purpose functions scanning WWD structures             |
725 rem | This gets the size of Application (sub)Window #aw%                       |
726 rem + ------------------------------------------------------------------------ +
727 :
728 def proc GetAWsize(wdp, aw%, x%, y%)
729 loc awp
730 rem Call with pointer to WWD, and AW number (EZP)
731 rem Returns x/y size in x%/y%
732 if aw% < 1 or aw% > peek_w(wdp + ww_nappl) then
733  x% = -1: y% = x%: ret
734 endif
735 rem Locate metrics in structure
736 awp = peek_l(peek_l(wdp + ww_pappl) + 4 * (aw% - 1)): rem awp = -> AW def
737 x% = peek_w(awp + wwa_xsiz): y% = peek_w(awp + wwa_ysiz)
738 enddef GetAWsize
739 :
740 :
741 rem + ------------------------------------------------------------------------ +
742 rem |<                                 Alloc                                  >|
743 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
744 rem | Wrapper for ALCHP                                                        |
745 rem | Expects QMenu's REPORT_ERROR                                             |
746 rem + ------------------------------------------------------------------------ +
747 :
748 def fn Alloc(size)
749 loc a
750 a = alchp(size)
751 if a > 0: ret a
752 if a = 0: a = -3: rem Err OM
753 ErrMess 'Error', 'Out of memory': quit a
754 enddef Alloc
755 :
756 :
757 rem + ------------------------------------------------------------------------ +
758 rem |<                             Sound Routines                             >|
759 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
760 :
761 def proc Ping: if sound: beep 2, 2: endif: enddef Ping
762 def proc Burp: if sound: beep 2000, 255: endif: enddef Burp
763 :
764 :
765 rem + ------------------------------------------------------------------------ +
766 rem |<                                 DESP$                                  >|
767 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
768 rem | De-space - remove leading spaces, if any                                 |
769 rem + ------------------------------------------------------------------------ +
770 :
771 DEFine FuNction DESP$(tx$)
772 LOCal i%
773 FOR i% = 1 TO LEN(tx$)
774  IF tx$(i%) <> ' ': RETurn tx$(i% TO LEN(tx$))
775 END FOR i%
776 RETurn ''
777 END DEFine
778 :
779 :
780 rem + ------------------------------------------------------------------------ +
781 rem |<                         Simple Center a String                         >|
782 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
783 :
784 def fn Center$(tx$, x%)
785 ret fill$(" ", (x% - len(tx$)) / 2) & tx$
786 enddef Center$
787 :
788 :
789 rem + ------------------------------------------------------------------------ +
790 rem |<                         External Error Message                         >|
791 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
792 rem | Display error message using MSX                                          |
793 rem + ------------------------------------------------------------------------ +
794 :
795 def proc ErrMess(tit$, str$)
796 Msx len(str$) + 2, tit$, str$, 1
797 enddef ErrMess
798 :
799 rem + ------------------------------------------------------------------------ +
800 rem |<                                  MSX                                   >|
801 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
802 rem | External messaging program                                               |
803 rem |                                                                          |
804 rem | This harness:                                                            |
805 rem | pjw, V0.01, July 11th 2017                                               |
806 rem | pjw, V0.02, July 13th 2017, WAKE buttonised job for input (else crash)   |
807 rem + ------------------------------------------------------------------------ +
808 :
809 def proc Msx(wid%, tit$, str$, er)
810 loc ch, x%, y%, cl$(128)
811 rem GLOBal ch%
812 if not fmsx: Burp: ret
813 if wwd = -1 then
814  x% = -1: y% = x%
815  ch = fopen('con_'): rdpt#ch; 48, x%, y%: close#ch
816  x% = x% - wid% * 3 + 3
817  y% = y% - 40
818 else
819  x% = peek_w(wwd + ww_xorg) - (wid% * 6 + 6 - peek_w(wwd + ww_xsize)) / 2
820  y% = peek_w(wwd + ww_yorg) + 40
821 endif
822 :
823 cl$ = '/X' & x% & ' /Y' & y% & ' /W' & wid% & ' /T' & tit$ & ' /S ' & str$
824 if er: cl$ = cl$ & '/Eon'
825 cl$ = cl$ & ' /P ' & hex$(palette, 32)
826 ExExt fmsx$, cl$
827 enddef Msx
828 :
829 :
